(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@rx-angular/cdk/template'), require('@angular/core'), require('@rx-angular/cdk/coercing'), require('@rx-angular/cdk/notifications'), require('rxjs'), require('rxjs/operators'), require('@rx-angular/cdk/render-strategies')) :
    typeof define === 'function' && define.amd ? define('@rx-angular/template/experimental/if', ['exports', '@rx-angular/cdk/template', '@angular/core', '@rx-angular/cdk/coercing', '@rx-angular/cdk/notifications', 'rxjs', 'rxjs/operators', '@rx-angular/cdk/render-strategies'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['rx-angular'] = global['rx-angular'] || {}, global['rx-angular'].template = global['rx-angular'].template || {}, global['rx-angular'].template.experimental = global['rx-angular'].template.experimental || {}, global['rx-angular'].template.experimental.if = {}), global.template, global.ng.core, global.coercing, global.notifications, global.rxjs, global.rxjs.operators, global.i1));
}(this, (function (exports, template, i0, coercing, notifications, rxjs, operators, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    var RxIfTemplateNames = Object.assign(Object.assign({}, template.RxBaseTemplateNames), { then: 'rxThen', else: 'rxElse' });

    // eslint-disable-next-line @angular-eslint/directive-class-suffix
    var RxIf = /** @class */ (function () {
        function RxIf(strategyProvider, cdRef, ngZone, thenTemplateRef, viewContainerRef) {
            var _this = this;
            this.strategyProvider = strategyProvider;
            this.cdRef = cdRef;
            this.ngZone = ngZone;
            this.thenTemplateRef = thenTemplateRef;
            this.viewContainerRef = viewContainerRef;
            this.subscription = new rxjs.Subscription();
            this.renderParent = this.strategyProvider.config.parent;
            this.patchZone = this.strategyProvider.config.patchZone;
            /** @internal */
            this.observablesHandler = notifications.createTemplateNotifier(function () { return !!_this.suspenseTmpl; });
            this.strategyHandler = coercing.coerceAllFactory(function () { return new rxjs.ReplaySubject(1); }, operators.mergeAll());
            this.rendered$ = new rxjs.Subject();
        }
        Object.defineProperty(RxIf.prototype, "rxIf", {
            set: function (potentialObservable) {
                this.observablesHandler.next(coercing.coerceObservable(potentialObservable));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RxIf.prototype, "strategy", {
            /* eslint-disable @angular-eslint/no-input-rename */
            set: function (strategyName) {
                this.strategyHandler.next(strategyName);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(RxIf.prototype, "renderCallback", {
            set: function (callback) {
                this._renderObserver = callback;
            },
            enumerable: false,
            configurable: true
        });
        RxIf.prototype.ngOnInit = function () {
            var _this = this;
            this.subscription.add(this.templateManager
                .render(this.observablesHandler.values$)
                .subscribe(function (n) {
                var _a;
                _this.rendered$.next(n);
                (_a = _this._renderObserver) === null || _a === void 0 ? void 0 : _a.next(n);
            }));
        };
        /** @internal */
        RxIf.prototype.ngOnChanges = function (changes) {
            if (!this.templateManager) {
                this._createTemplateManager();
            }
            if (changes.else) {
                this.templateManager.addTemplateRef(RxIfTemplateNames.else, this.else);
            }
            if (changes.completeTmpl) {
                this.templateManager.addTemplateRef(RxIfTemplateNames.complete, this.completeTmpl);
            }
            if (changes.suspenseTmpl) {
                this.templateManager.addTemplateRef(RxIfTemplateNames.suspense, this.suspenseTmpl);
            }
            if (changes.errorTmpl) {
                this.templateManager.addTemplateRef(RxIfTemplateNames.error, this.errorTmpl);
            }
        };
        RxIf.prototype.ngOnDestroy = function () {
            this.subscription.unsubscribe();
        };
        RxIf.prototype._createTemplateManager = function () {
            var _b;
            this.templateManager = template.createTemplateManager({
                templateSettings: {
                    viewContainerRef: this.viewContainerRef,
                    createViewContext: createViewContext,
                    updateViewContext: updateViewContext,
                    customContext: function (rxIf) { return ({ rxIf: rxIf }); },
                    patchZone: this.patchZone ? this.ngZone : false,
                },
                renderSettings: {
                    cdRef: this.cdRef,
                    parent: coerceBooleanProperty(this.renderParent),
                    patchZone: this.patchZone ? this.ngZone : false,
                    defaultStrategyName: this.strategyProvider.primaryStrategy,
                    strategies: this.strategyProvider.strategies,
                },
                notificationToTemplateName: (_b = {},
                    _b["suspense" /* Suspense */] = function () { return RxIfTemplateNames.suspense; },
                    _b["next" /* Next */] = function (value, templates) {
                        return value
                            ? RxIfTemplateNames.then
                            : templates.get(RxIfTemplateNames.else)
                                ? RxIfTemplateNames.else
                                : undefined;
                    },
                    _b["error" /* Error */] = function () { return RxIfTemplateNames.error; },
                    _b["complete" /* Complete */] = function () { return RxIfTemplateNames.complete; },
                    _b),
            });
            this.templateManager.addTemplateRef(RxIfTemplateNames.then, this.thenTemplateRef);
            this.templateManager.nextStrategy(this.strategyHandler.values$);
        };
        return RxIf;
    }());
    /** @nocollapse */ RxIf.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: RxIf, deps: [{ token: i1__namespace.RxStrategyProvider }, { token: i0__namespace.ChangeDetectorRef }, { token: i0__namespace.NgZone }, { token: i0__namespace.TemplateRef }, { token: i0__namespace.ViewContainerRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    /** @nocollapse */ RxIf.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.16", type: RxIf, selector: "[rxIf]", inputs: { rxIf: "rxIf", strategy: ["rxIfStrategy", "strategy"], else: ["rxIfElse", "else"], suspenseTmpl: ["rxIfSuspenseTpl", "suspenseTmpl"], completeTmpl: ["rxIfCompleteTpl", "completeTmpl"], errorTmpl: ["rxIfErrorTpl", "errorTmpl"], renderParent: ["rxIfParent", "renderParent"], patchZone: ["rxIfPatchZone", "patchZone"], renderCallback: ["rxIfRenderCallback", "renderCallback"] }, usesOnChanges: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: RxIf, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[rxIf]',
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.RxStrategyProvider }, { type: i0__namespace.ChangeDetectorRef }, { type: i0__namespace.NgZone }, { type: i0__namespace.TemplateRef }, { type: i0__namespace.ViewContainerRef }]; }, propDecorators: { rxIf: [{
                    type: i0.Input
                }], strategy: [{
                    type: i0.Input,
                    args: ['rxIfStrategy']
                }], else: [{
                    type: i0.Input,
                    args: ['rxIfElse']
                }], suspenseTmpl: [{
                    type: i0.Input,
                    args: ['rxIfSuspenseTpl']
                }], completeTmpl: [{
                    type: i0.Input,
                    args: ['rxIfCompleteTpl']
                }], errorTmpl: [{
                    type: i0.Input,
                    args: ['rxIfErrorTpl']
                }], renderParent: [{
                    type: i0.Input,
                    args: ['rxIfParent']
                }], patchZone: [{
                    type: i0.Input,
                    args: ['rxIfPatchZone']
                }], renderCallback: [{
                    type: i0.Input,
                    args: ['rxIfRenderCallback']
                }] } });
    function createViewContext(value) {
        return {
            rxIf: value,
            $implicit: value,
            $error: false,
            $complete: false,
            $suspense: false,
        };
    }
    function updateViewContext(value, view, context) {
        Object.keys(context).forEach(function (k) {
            view.context[k] = context[k];
        });
    }
    /**
     * Coerces a data-bound value (typically a string) to a boolean.
     */
    function coerceBooleanProperty(value) {
        return value != null && "" + value !== 'false';
    }

    var DECLARATIONS = [RxIf];
    var IfModule = /** @class */ (function () {
        function IfModule() {
        }
        return IfModule;
    }());
    /** @nocollapse */ IfModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: IfModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    /** @nocollapse */ IfModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: IfModule, declarations: [RxIf], exports: [RxIf] });
    /** @nocollapse */ IfModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: IfModule, imports: [[]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: IfModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: DECLARATIONS,
                        imports: [],
                        exports: DECLARATIONS,
                    }]
            }] });

    /**
     * Generated bundle index. Do not edit.
     */

    exports.IfModule = IfModule;
    exports.RxIf = RxIf;
    exports.RxIfTemplateNames = RxIfTemplateNames;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=template-experimental-if.umd.js.map
