import { ChangeDetectorRef, NgZone, OnDestroy, OnInit, SimpleChanges, TemplateRef, ViewContainerRef } from '@angular/core';
import { RxStrategyProvider } from '@rx-angular/cdk/render-strategies';
import { NextObserver, Observable } from 'rxjs';
import * as i0 from "@angular/core";
export declare class RxIf<U> implements OnInit, OnDestroy {
    private strategyProvider;
    private cdRef;
    private ngZone;
    private readonly thenTemplateRef;
    private readonly viewContainerRef;
    private subscription;
    private _renderObserver;
    private templateManager;
    set rxIf(potentialObservable: Observable<U> | U | null | undefined);
    set strategy(strategyName: Observable<string> | string | null | undefined);
    else: TemplateRef<any>;
    suspenseTmpl: TemplateRef<any>;
    completeTmpl: TemplateRef<any>;
    errorTmpl: TemplateRef<any>;
    renderParent: boolean;
    patchZone: boolean;
    set renderCallback(callback: NextObserver<U>);
    /** @internal */
    private observablesHandler;
    private readonly strategyHandler;
    private readonly rendered$;
    constructor(strategyProvider: RxStrategyProvider, cdRef: ChangeDetectorRef, ngZone: NgZone, thenTemplateRef: TemplateRef<any>, viewContainerRef: ViewContainerRef);
    ngOnInit(): void;
    /** @internal */
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private _createTemplateManager;
    static ɵfac: i0.ɵɵFactoryDeclaration<RxIf<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<RxIf<any>, "[rxIf]", never, { "rxIf": "rxIf"; "strategy": "rxIfStrategy"; "else": "rxIfElse"; "suspenseTmpl": "rxIfSuspenseTpl"; "completeTmpl": "rxIfCompleteTpl"; "errorTmpl": "rxIfErrorTpl"; "renderParent": "rxIfParent"; "patchZone": "rxIfPatchZone"; "renderCallback": "rxIfRenderCallback"; }, {}, never>;
}
